474 Ones and Zeroes
In the computer world, use restricted resource you have to generate maximum benefit is what we always want to pursue.
For now, suppose you are a dominator of m 0s
and n 1s
respectively. On the other hand, there is an array with strings consisting of only 0s
and 1s
.
Now your task is to find the maximum number of strings that you can form with given m 0s
and n 1s
. Each 0
and 1
can be used at most once.
Note:
- The given numbers of
0s
and1s
will both not exceed100
- The size of given string array won’t exceed
600
.
Example 1:
|
|
Example 2:
|
|
思路
The problem is really a knapsack-ish problem, so I knew DP was the way to go. In this problem, we have two knapsacks, one with capacity m and another with capacity n. The ‘weight’ of each item is the number of ones and zeroes in it. And the ‘value’ of each item is exactly one, since we just want to maximize the number of items. So for each item, i.e. s
, we calculate its weight first and use DP for the rest. If you are unfamiliar with knapsack, maybe reading this will help a little bit.
dp(i)(j) = the max number of strings that can be formed with i 0’s and j 1’s from the first few strings up to the current string s Catch: have to go from bottom right to top left
Why? If a cell in the memo is updated(because s is selected), we should be adding 1 to dp[i][j] from the previous iteration (when we were not considering s)
If we go from top left to bottom right, we would be using results from this iteration => overcounting
|
|
参考资料:https://discuss.leetcode.com/topic/71438/c-dp-solution-with-comments/4